﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;

namespace HierarchicalHeaderAlignment
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {

            InitializeComponent();

            Data = new ObservableCollection<Level0>();

            for (int i = 0; i < 10; i++)
            {
                Level0 lvl = new Level0
                {
                    Id = i,
                    Name = "Level0 - " + i,
                    ChildLevel1 = new ObservableCollection<Level1>()
                };

                for (int j = 0; j < 5; j++)
                {
                    Level1 lvl1 = new Level1
                    {
                        Id = j,
                        Name = "Lavel1 - " + j,
                        Parent = lvl.Name,
                        ChildLevel1 = new ObservableCollection<Level2>()
                    };

                    for (int p = 0; p < 5; p++)
                    {
                        Level2 lvl2 = new Level2
                        {
                            Id = p,
                            Name = "Level2 - " + p,
                            Parent = lvl1.Name,
                            ChildLevel1 = new ObservableCollection<Level3>()
                        };

                        for (int q = 0; q < 5; q++)
                        {
                            lvl2.ChildLevel1.Add(new Level3 { Id = q, Name = "Level3 - " + q, Parent = lvl2.Name });
                        }

                        lvl1.ChildLevel1.Add(lvl2);
                    }

                    lvl.ChildLevel1.Add(lvl1);
                }

                Data.Add(lvl);
            }

            DataContext = this;
        }

        public ObservableCollection<Level0> Data { get; set; }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            DataRecordPresenter drp = DataRecordPresenter.FromRecord(xamDataGrid1.Records[0]) as DataRecordPresenter;

            
            DataRecordCellArea drca = Utilities.GetDescendantFromType(DataRecordPresenter.FromRecord(xamDataGrid1.Records[0]), typeof(DataRecordCellArea), false) as DataRecordCellArea;
            drca.Foreground = Brushes.Red;
        }
        
        private void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            if (e.FieldLayout.DataPresenter.FieldLayouts.IndexOf(e.FieldLayout) == 1)
            {
                e.FieldLayout.Settings.RecordSelectorExtent = e.FieldLayout.RecordSelectorExtentResolved - 1;
            }
            if (e.FieldLayout.DataPresenter.FieldLayouts.IndexOf(e.FieldLayout) > 1)
            {
                e.FieldLayout.Settings.RecordSelectorExtent = 1;
            }
        }
    }

    public class Level0
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public ObservableCollection<Level1> ChildLevel1 { get; set; }
    }

    public class Level1
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Parent { get; set; }
        public ObservableCollection<Level2> ChildLevel1 { get; set; }
    }

    public class Level2
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Parent { get; set; }
        public ObservableCollection<Level3> ChildLevel1 { get; set; }
    }

    public class Level3
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Parent { get; set; }
    }
}
